summaryrefslogtreecommitdiffstats
path: root/tools
diff options
context:
space:
mode:
authoremaste <emaste@FreeBSD.org>2012-09-26 00:25:09 +0000
committeremaste <emaste@FreeBSD.org>2012-09-26 00:25:09 +0000
commitdb806db21daf7ffdc8c1ec97bf92acec601e6220 (patch)
tree6dcbef958d6a2b07cf7c025602a0e1254ff9daa9 /tools
parent3a425ea5d62ca28cadd276c238ebda39e233dffe (diff)
downloadFreeBSD-src-db806db21daf7ffdc8c1ec97bf92acec601e6220.zip
FreeBSD-src-db806db21daf7ffdc8c1ec97bf92acec601e6220.tar.gz
Add regression test for kern/172075.
Sponsored by: ADARA Networks PR: kern/172075
Diffstat (limited to 'tools')
-rw-r--r--tools/regression/net/if_tap/test-tap.sh59
1 files changed, 59 insertions, 0 deletions
diff --git a/tools/regression/net/if_tap/test-tap.sh b/tools/regression/net/if_tap/test-tap.sh
new file mode 100644
index 0000000..3721556
--- /dev/null
+++ b/tools/regression/net/if_tap/test-tap.sh
@@ -0,0 +1,59 @@
+#!/bin/sh
+
+# Copyright (C) 2012 ADARA Networks. All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+
+tap_exists()
+{
+ ls -1 /dev | grep -q "$1"
+}
+
+if [ $(id -u) -ne 0 ]; then
+ echo "Must be root" >&2
+ exit 1
+fi
+
+set -e
+
+# Base case create & destroy
+tap=$(ifconfig tap create)
+tap_exists $tap
+ifconfig $tap destroy
+! tap_exists $tap
+
+# kern/172075: INVARIANTS kernel panicked when destroying an in-use tap(4)
+# Fixed in HEAD r240938.
+tap=$(ifconfig tap create)
+tap_exists $tap
+cat /dev/$tap > /dev/null &
+catpid=$!
+sleep 0.1
+ifconfig $tap destroy &
+sleep 0.1
+kill $catpid
+! tap_exists $tap
+
+echo PASS
+exit 0
OpenPOWER on IntegriCloud